StandardSession (Tomcat API Documentation)
Keywords: org.apache.catalina.session.StandardSession class

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.catalina.session
Class StandardSession

    java.lang.Object
      org.apache.catalina.session.StandardSession

All Implemented Interfaces:
  java.io.Serializable, javax.servlet.http.HttpSession, Session

Direct Known Subclasses:
  DeltaSession, ReplicatedSession

    public class StandardSession

extends java.lang.Object
implements javax.servlet.http.HttpSession, Session, java.io.Serializable

Standard implementation of the Session interface. This object is serializable, so that it can be stored in persistent storage or transferred to a different JVM for distributable session support.

IMPLEMENTATION NOTE: An instance of this class represents both the internal (Session) and application level (HttpSession) view of the session. However, because the class itself is not declared public, Java logic outside of the `org.apache.catalina.session` package cannot cast an HttpSession view of this instance back to a Session view.

IMPLEMENTATION NOTE: If you add fields to this class, you must make sure that you carry them over in the read/writeObject methods so that this class is properly serialized.

Version:
  $Revision: 711589 $ $Date: 2008-11-05 16:41:03 +0100 (Wed, 05 Nov 2008) $
Author:
  Craig R. McClanahan, Sean Legassick, Jon S. Stevens
See Also:
  Serialized Form

Field Summary
`protected java.util.concurrent.atomic.AtomicInteger` | `accessCount` The access count for this session.
`protected static boolean` | `ACTIVITY_CHECK`
`protected java.util.Map` | `attributes` The collection of user data attributes associated with this Session.
`protected java.lang.String` | `authType` The authentication type used to authenticate our cached Principal, if any.
`protected java.lang.reflect.Method` | `containerEventMethod` The `java.lang.Method` for the `fireContainerEvent()` method of the `org.apache.catalina.core.StandardContext` method, if our Context implementation is of this class.
`protected static java.lang.Class[]` | `containerEventTypes` The method signature for the `fireContainerEvent` method.
`protected long` | `creationTime` The time this session was created, in milliseconds since midnight, January 1, 1970 GMT.
`protected static java.lang.String[]` | `EMPTY_ARRAY` Type array.
`protected static java.lang.String[]` | `excludedAttributes` Set of attribute names which are not allowed to be persisted.
`protected boolean` | `expiring` We are currently processing a session expiration, so bypass certain IllegalStateException tests.
`protected StandardSessionFacade` | `facade` The facade associated with this session.
`protected java.lang.String` | `id` The session identifier of this Session.
`protected static java.lang.String` | `info` Descriptive information describing this Session implementation.
`protected boolean` | `isNew` Flag indicating whether this session is new or not.
`protected boolean` | `isValid` Flag indicating whether this session is valid or not.
`protected long` | `lastAccessedTime` The last accessed time for this Session.
`protected java.util.ArrayList` | `listeners` The session event listeners for this Session.
`protected Manager` | `manager` The Manager with which this Session is associated.
`protected int` | `maxInactiveInterval` The maximum time interval, in seconds, between client requests before the servlet container may invalidate this session.
`protected static java.lang.String` | `NOT_SERIALIZED` The dummy attribute value serialized when a NotSerializableException is encountered in `writeObject()`.
`protected java.util.Map` | `notes` Internal notes associated with this session by Catalina components and event listeners.
`protected java.security.Principal` | `principal` The authenticated Principal associated with this session, if any.
`protected static javax.servlet.http.HttpSessionContext` | `sessionContext` The HTTP session context associated with this session.
`protected static StringManager` | `sm` The string manager for this package.
`protected java.beans.PropertyChangeSupport` | `support` The property change support for this component.
`protected long` | `thisAccessedTime` The current accessed time for this session.

Fields inherited from interface org.apache.catalina.Session
`SESSION_ACTIVATED_EVENT, SESSION_CREATED_EVENT, SESSION_DESTROYED_EVENT, SESSION_PASSIVATED_EVENT`

Constructor Summary
`StandardSession(Manager manager)` Construct a new Session associated with the specified Manager.

Method Summary
`void` | `access()` Update the accessed time information for this session.
`void` | `activate()` Perform internal processing required to activate this session.
`void` | `addSessionListener(SessionListener listener)` Add a session event listener to this component.
`void` | `endAccess()` End the access.
`protected boolean` | `exclude(java.lang.String name)` Exclude attribute that cannot be serialized.
`void` | `expire()` Perform the internal processing required to invalidate this session, without triggering an exception if the session has already expired.
`void` | `expire(boolean notify)` Perform the internal processing required to invalidate this session, without triggering an exception if the session has already expired.
`protected void` | `fireContainerEvent(Context context, java.lang.String type, java.lang.Object data)` Fire container events if the Context implementation is the `org.apache.catalina.core.StandardContext`.
`void` | `fireSessionEvent(java.lang.String type, java.lang.Object data)` Notify all session event listeners that a particular event has occurred for this Session.
`java.lang.Object` | `getAttribute(java.lang.String name)` Return the object bound with the specified name in this session, or `null` if no object is bound with that name.
`java.util.Enumeration` | `getAttributeNames()` Return an `Enumeration` of `String` objects containing the names of the objects bound to this session.
`java.lang.String` | `getAuthType()` Return the authentication type used to authenticate our cached Principal, if any.
`long` | `getCreationTime()` Return the time when this session was created, in milliseconds since midnight, January 1, 1970 GMT.
`java.lang.String` | `getId()` Return the session identifier for this session.
`java.lang.String` | `getIdInternal()` Return the session identifier for this session.
`java.lang.String` | `getInfo()` Return descriptive information about this Session implementation and the corresponding version number, in the format `<description>/<version>`.
`long` | `getLastAccessedTime()` Return the last time the client sent a request associated with this session, as the number of milliseconds since midnight, January 1, 1970 GMT.
`long` | `getLastAccessedTimeInternal()` Return the last client access time without invalidation check
`Manager` | `getManager()` Return the Manager within which this Session is valid.
`int` | `getMaxInactiveInterval()` Return the maximum time interval, in seconds, between client requests before the servlet container will invalidate the session.
`java.lang.Object` | `getNote(java.lang.String name)` Return the object bound with the specified name to the internal notes for this session, or `null` if no such binding exists.
`java.util.Iterator` | `getNoteNames()` Return an Iterator containing the String names of all notes bindings that exist for this session.
`java.security.Principal` | `getPrincipal()` Return the authenticated Principal that is associated with this Session.
`javax.servlet.ServletContext` | `getServletContext()` Return the ServletContext to which this session belongs.
`javax.servlet.http.HttpSession` | `getSession()` Return the `HttpSession` for which this object is the facade.
`javax.servlet.http.HttpSessionContext` | `getSessionContext()` Deprecated. As of Version 2.1, this method is deprecated and has no replacement. It will be removed in a future version of the Java Servlet API.
`java.lang.Object` | `getValue(java.lang.String name)` Deprecated. As of Version 2.2, this method is replaced by `getAttribute()`
`java.lang.String[]` | `getValueNames()` Deprecated. As of Version 2.2, this method is replaced by `getAttributeNames()`
`void` | `invalidate()` Invalidates this session and unbinds any objects bound to it.
`boolean` | `isNew()` Return `true` if the client does not yet know about the session, or if the client chooses not to join the session.
`boolean` | `isValid()` Return the `isValid` flag for this session.
`protected boolean` | `isValidInternal()` Return the `isValid` flag for this session without any expiration check.
`protected java.lang.String[]` | `keys()` Return the names of all currently defined session attributes as an array of Strings.
`void` | `passivate()` Perform the internal processing required to passivate this session.
`void` | `putValue(java.lang.String name, java.lang.Object value)` Deprecated. As of Version 2.2, this method is replaced by `setAttribute()`
`protected void` | `readObject(java.io.ObjectInputStream stream)` Read a serialized version of this session object from the specified object input stream.
`void` | `readObjectData(java.io.ObjectInputStream stream)` Read a serialized version of the contents of this session object from the specified object input stream, without requiring that the StandardSession itself have been serialized.
`void` | `recycle()` Release all object references, and initialize instance variables, in preparation for reuse of this object.
`void` | `removeAttribute(java.lang.String name)` Remove the object bound with the specified name from this session.
`void` | `removeAttribute(java.lang.String name, boolean notify)` Remove the object bound with the specified name from this session.
`protected void` | `removeAttributeInternal(java.lang.String name, boolean notify)` Remove the object bound with the specified name from this session.
`void` | `removeNote(java.lang.String name)` Remove any object bound to the specified name in the internal notes for this session.
`void` | `removeSessionListener(SessionListener listener)` Remove a session event listener from this component.
`void` | `removeValue(java.lang.String name)` Deprecated. As of Version 2.2, this method is replaced by `removeAttribute()`
`void` | `setAttribute(java.lang.String name, java.lang.Object value)` Bind an object to this session, using the specified name.
`void` | `setAttribute(java.lang.String name, java.lang.Object value, boolean notify)` Bind an object to this session, using the specified name.
`void` | `setAuthType(java.lang.String authType)` Set the authentication type used to authenticate our cached Principal, if any.
`void` | `setCreationTime(long time)` Set the creation time for this session.
`void` | `setId(java.lang.String id)` Set the session identifier for this session.
`void` | `setManager(Manager manager)` Set the Manager within which this Session is valid.
`void` | `setMaxInactiveInterval(int interval)` Set the maximum time interval, in seconds, between client requests before the servlet container will invalidate the session.
`void` | `setNew(boolean isNew)` Set the `isNew` flag for this session.
`void` | `setNote(java.lang.String name, java.lang.Object value)` Bind an object to a specified name in the internal notes associated with this session, replacing any existing binding for this name.
`void` | `setPrincipal(java.security.Principal principal)` Set the authenticated Principal that is associated with this Session.
`void` | `setValid(boolean isValid)` Set the `isValid` flag for this session.
`void` | `tellNew()` Inform the listeners about the new session.
`java.lang.String` | `toString()` Return a string representation of this object.
`protected void` | `writeObject(java.io.ObjectOutputStream stream)` Write a serialized version of this session object to the specified object output stream.
`void` | `writeObjectData(java.io.ObjectOutputStream stream)` Write a serialized version of the contents of this session object to the specified object output stream, without requiring that the StandardSession itself have been serialized.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### ACTIVITY_CHECK

    protected static final boolean ACTIVITY_CHECK

### EMPTY_ARRAY

    protected static final java.lang.String[] EMPTY_ARRAY

  Type array.

### NOT_SERIALIZED

    protected static final java.lang.String NOT_SERIALIZED

  The dummy attribute value serialized when a NotSerializableException is encountered in `writeObject()`.

  See Also:
    Constant Field Values

### attributes

    protected java.util.Map attributes

  The collection of user data attributes associated with this Session.

### authType

    protected transient java.lang.String authType

  The authentication type used to authenticate our cached Principal, if any. NOTE: This value is not included in the serialized version of this object.

### containerEventMethod

    protected transient java.lang.reflect.Method containerEventMethod

  The `java.lang.Method` for the `fireContainerEvent()` method of the `org.apache.catalina.core.StandardContext` method, if our Context implementation is of this class. This value is computed dynamically the first time it is needed, or after a session reload (since it is declared transient).

### containerEventTypes

    protected static final java.lang.Class[] containerEventTypes

  The method signature for the `fireContainerEvent` method.

### creationTime

    protected long creationTime

  The time this session was created, in milliseconds since midnight, January 1, 1970 GMT.

### excludedAttributes

    protected static final java.lang.String[] excludedAttributes

  Set of attribute names which are not allowed to be persisted.

### expiring

    protected transient boolean expiring

  We are currently processing a session expiration, so bypass certain IllegalStateException tests. NOTE: This value is not included in the serialized version of this object.

### facade

    protected transient StandardSessionFacade facade

  The facade associated with this session. NOTE: This value is not included in the serialized version of this object.

### id

    protected java.lang.String id

  The session identifier of this Session.

### info

    protected static final java.lang.String info

  Descriptive information describing this Session implementation.

  See Also:
    Constant Field Values

### lastAccessedTime

    protected volatile long lastAccessedTime

  The last accessed time for this Session.

### listeners

    protected transient java.util.ArrayList listeners

  The session event listeners for this Session.

### manager

    protected transient Manager manager

  The Manager with which this Session is associated.

### maxInactiveInterval

    protected int maxInactiveInterval

  The maximum time interval, in seconds, between client requests before the servlet container may invalidate this session. A negative time indicates that the session should never time out.

### isNew

    protected boolean isNew

  Flag indicating whether this session is new or not.

### isValid

    protected boolean isValid

  Flag indicating whether this session is valid or not.

### notes

    protected transient java.util.Map notes

  Internal notes associated with this session by Catalina components and event listeners. IMPLEMENTATION NOTE: This object is not saved and restored across session serializations!

### principal

    protected transient java.security.Principal principal

  The authenticated Principal associated with this session, if any. IMPLEMENTATION NOTE: This object is not saved and restored across session serializations!

### sm

    protected static StringManager sm

  The string manager for this package.

### sessionContext

    protected static javax.servlet.http.HttpSessionContext sessionContext

  The HTTP session context associated with this session.

### support

    protected transient java.beans.PropertyChangeSupport support

  The property change support for this component. NOTE: This value is not included in the serialized version of this object.

### thisAccessedTime

    protected volatile long thisAccessedTime

  The current accessed time for this session.

### accessCount

    protected transient java.util.concurrent.atomic.AtomicInteger accessCount

  The access count for this session.

Constructor Detail

### StandardSession

    public StandardSession(Manager manager)

  Construct a new Session associated with the specified Manager.

  Parameters:
    `manager` - The manager with which this Session is associated

Method Detail

### getAuthType

    public java.lang.String getAuthType()

  Return the authentication type used to authenticate our cached Principal, if any.

  Specified by:
    `getAuthType` in interface `Session`

### setAuthType

    public void setAuthType(java.lang.String authType)

  Set the authentication type used to authenticate our cached Principal, if any.

  Specified by:
    `setAuthType` in interface `Session`
  Parameters:
    `authType` - The new cached authentication type

### setCreationTime

    public void setCreationTime(long time)

  Set the creation time for this session. This method is called by the Manager when an existing Session instance is reused.

  Specified by:
    `setCreationTime` in interface `Session`
  Parameters:
    `time` - The new creation time

### getId

    public java.lang.String getId()

  Return the session identifier for this session.

  Specified by:
    `getId` in interface `javax.servlet.http.HttpSession`
  Specified by:
    `getId` in interface `Session`
  Returns:
    a string specifying the identifier assigned to this session

### getIdInternal

    public java.lang.String getIdInternal()

  Return the session identifier for this session.

  Specified by:
    `getIdInternal` in interface `Session`

### setId

    public void setId(java.lang.String id)

  Set the session identifier for this session.

  Specified by:
    `setId` in interface `Session`
  Parameters:
    `id` - The new session identifier

### tellNew

    public void tellNew()

  Inform the listeners about the new session.

### getInfo

    public java.lang.String getInfo()

  Return descriptive information about this Session implementation and the corresponding version number, in the format `<description>/<version>`.

  Specified by:
    `getInfo` in interface `Session`

### getLastAccessedTime

    public long getLastAccessedTime()

  Return the last time the client sent a request associated with this session, as the number of milliseconds since midnight, January 1, 1970 GMT. Actions that your application takes, such as getting or setting a value associated with the session, do not affect the access time.

  Specified by:
    `getLastAccessedTime` in interface `javax.servlet.http.HttpSession`
  Specified by:
    `getLastAccessedTime` in interface `Session`
  Returns:
    a `long` representing the last time the client sent a request associated with this session, expressed in milliseconds since 1/1/1970 GMT

### getLastAccessedTimeInternal

    public long getLastAccessedTimeInternal()

  Return the last client access time without invalidation check

  Specified by:
    `getLastAccessedTimeInternal` in interface `Session`
  See Also:
    `getLastAccessedTime().`

### getManager

    public Manager getManager()

  Return the Manager within which this Session is valid.

  Specified by:
    `getManager` in interface `Session`

### setManager

    public void setManager(Manager manager)

  Set the Manager within which this Session is valid.

  Specified by:
    `setManager` in interface `Session`
  Parameters:
    `manager` - The new Manager

### getMaxInactiveInterval

    public int getMaxInactiveInterval()

  Return the maximum time interval, in seconds, between client requests before the servlet container will invalidate the session. A negative time indicates that the session should never time out.

  Specified by:
    `getMaxInactiveInterval` in interface `javax.servlet.http.HttpSession`
  Specified by:
    `getMaxInactiveInterval` in interface `Session`
  Returns:
    an integer specifying the number of seconds this session remains open between client requests
  See Also:
    `HttpSession.setMaxInactiveInterval(int)`

### setMaxInactiveInterval

    public void setMaxInactiveInterval(int interval)

  Set the maximum time interval, in seconds, between client requests before the servlet container will invalidate the session. A negative time indicates that the session should never time out.

  Specified by:
    `setMaxInactiveInterval` in interface `javax.servlet.http.HttpSession`
  Specified by:
    `setMaxInactiveInterval` in interface `Session`
  Parameters:
    `interval` - The new maximum interval

### setNew

    public void setNew(boolean isNew)

  Set the `isNew` flag for this session.

  Specified by:
    `setNew` in interface `Session`
  Parameters:
    `isNew` - The new value for the `isNew` flag

### getPrincipal

    public java.security.Principal getPrincipal()

  Return the authenticated Principal that is associated with this Session. This provides an `Authenticator` with a means to cache a previously authenticated Principal, and avoid potentially expensive `Realm.authenticate()` calls on every request. If there is no current associated Principal, return `null`.

  Specified by:
    `getPrincipal` in interface `Session`

### setPrincipal

    public void setPrincipal(java.security.Principal principal)

  Set the authenticated Principal that is associated with this Session. This provides an `Authenticator` with a means to cache a previously authenticated Principal, and avoid potentially expensive `Realm.authenticate()` calls on every request.

  Specified by:
    `setPrincipal` in interface `Session`
  Parameters:
    `principal` - The new Principal, or `null` if none

### getSession

    public javax.servlet.http.HttpSession getSession()

  Return the `HttpSession` for which this object is the facade.

  Specified by:
    `getSession` in interface `Session`

### isValid

    public boolean isValid()

  Return the `isValid` flag for this session.

  Specified by:
    `isValid` in interface `Session`

### setValid

    public void setValid(boolean isValid)

  Set the `isValid` flag for this session.

  Specified by:
    `setValid` in interface `Session`
  Parameters:
    `isValid` - The new value for the `isValid` flag

### access

    public void access()

  Update the accessed time information for this session. This method should be called by the context when a request comes in for a particular session, even if the application does not reference it.

  Specified by:
    `access` in interface `Session`

### endAccess

    public void endAccess()

  End the access.

  Specified by:
    `endAccess` in interface `Session`

### addSessionListener

    public void addSessionListener(SessionListener listener)

  Add a session event listener to this component.

  Specified by:
    `addSessionListener` in interface `Session`

### expire

    public void expire()

  Perform the internal processing required to invalidate this session, without triggering an exception if the session has already expired.

  Specified by:
    `expire` in interface `Session`

### expire

    public void expire(boolean notify)

  Perform the internal processing required to invalidate this session, without triggering an exception if the session has already expired.

  Parameters:
    `notify` - Should we notify listeners about the demise of this session?

### passivate

    public void passivate()

  Perform the internal processing required to passivate this session.

### activate

    public void activate()

  Perform internal processing required to activate this session.

### getNote

    public java.lang.Object getNote(java.lang.String name)

  Return the object bound with the specified name to the internal notes for this session, or `null` if no such binding exists.

  Specified by:
    `getNote` in interface `Session`
  Parameters:
    `name` - Name of the note to be returned

### getNoteNames

    public java.util.Iterator getNoteNames()

  Return an Iterator containing the String names of all notes bindings that exist for this session.

  Specified by:
    `getNoteNames` in interface `Session`

### recycle

    public void recycle()

  Release all object references, and initialize instance variables, in preparation for reuse of this object.

  Specified by:
    `recycle` in interface `Session`

### removeNote

    public void removeNote(java.lang.String name)

  Remove any object bound to the specified name in the internal notes for this session.

  Specified by:
    `removeNote` in interface `Session`
  Parameters:
    `name` - Name of the note to be removed

### removeSessionListener

    public void removeSessionListener(SessionListener listener)

  Remove a session event listener from this component.

  Specified by:
    `removeSessionListener` in interface `Session`

### setNote

    public void setNote(java.lang.String name,
                        java.lang.Object value)

  Bind an object to a specified name in the internal notes associated with this session, replacing any existing binding for this name.

  Specified by:
    `setNote` in interface `Session`
  Parameters:
    `name` - Name to which the object should be bound
    `value` - Object to be bound to the specified name

### toString

    public java.lang.String toString()

  Return a string representation of this object.

  Overrides:
    `toString` in class `java.lang.Object`

### readObjectData

    public void readObjectData(java.io.ObjectInputStream stream)
                        throws java.lang.ClassNotFoundException,
                               java.io.IOException

  Read a serialized version of the contents of this session object from the specified object input stream, without requiring that the StandardSession itself have been serialized.

  Parameters:
    `stream` - The object input stream to read from
  Throws:
    `java.lang.ClassNotFoundException` - if an unknown class is specified
    `java.io.IOException` - if an input/output error occurs

### writeObjectData

    public void writeObjectData(java.io.ObjectOutputStream stream)
                         throws java.io.IOException

  Write a serialized version of the contents of this session object to the specified object output stream, without requiring that the StandardSession itself have been serialized.

  Parameters:
    `stream` - The object output stream to write to
  Throws:
    `java.io.IOException` - if an input/output error occurs

### getCreationTime

    public long getCreationTime()

  Return the time when this session was created, in milliseconds since midnight, January 1, 1970 GMT.

  Specified by:
    `getCreationTime` in interface `javax.servlet.http.HttpSession`
  Specified by:
    `getCreationTime` in interface `Session`
  Returns:
    a `long` specifying when this session was created, expressed in milliseconds since 1/1/1970 GMT
  Throws:
    `java.lang.IllegalStateException` - if this method is called on an invalidated session

### getServletContext

    public javax.servlet.ServletContext getServletContext()

  Return the ServletContext to which this session belongs.

  Specified by:
    `getServletContext` in interface `javax.servlet.http.HttpSession`
  Returns:
    The ServletContext object for the web application

### getSessionContext

    public javax.servlet.http.HttpSessionContext getSessionContext()

  Deprecated. As of Version 2.1, this method is deprecated and has no replacement. It will be removed in a future version of the Java Servlet API.

  Return the session context with which this session is associated.

  Specified by:
    `getSessionContext` in interface `javax.servlet.http.HttpSession`

### getAttribute

    public java.lang.Object getAttribute(java.lang.String name)

  Return the object bound with the specified name in this session, or `null` if no object is bound with that name.

  Specified by:
    `getAttribute` in interface `javax.servlet.http.HttpSession`
  Parameters:
    `name` - Name of the attribute to be returned
  Returns:
    the object with the specified name
  Throws:
    `java.lang.IllegalStateException` - if this method is called on an invalidated session

### getAttributeNames

    public java.util.Enumeration getAttributeNames()

  Return an `Enumeration` of `String` objects containing the names of the objects bound to this session.

  Specified by:
    `getAttributeNames` in interface `javax.servlet.http.HttpSession`
  Returns:
    an `Enumeration` of `String` objects specifying the names of all the objects bound to this session
  Throws:
    `java.lang.IllegalStateException` - if this method is called on an invalidated session

### getValue

    public java.lang.Object getValue(java.lang.String name)

  Deprecated. As of Version 2.2, this method is replaced by `getAttribute()`

  Return the object bound with the specified name in this session, or `null` if no object is bound with that name.

  Specified by:
    `getValue` in interface `javax.servlet.http.HttpSession`
  Parameters:
    `name` - Name of the value to be returned
  Returns:
    the object with the specified name
  Throws:
    `java.lang.IllegalStateException` - if this method is called on an invalidated session

### getValueNames

    public java.lang.String[] getValueNames()

  Deprecated. As of Version 2.2, this method is replaced by `getAttributeNames()`

  Return the set of names of objects bound to this session. If there are no such objects, a zero-length array is returned.

  Specified by:
    `getValueNames` in interface `javax.servlet.http.HttpSession`
  Returns:
    an array of `String` objects specifying the names of all the objects bound to this session
  Throws:
    `java.lang.IllegalStateException` - if this method is called on an invalidated session

### invalidate

    public void invalidate()

  Invalidates this session and unbinds any objects bound to it.

  Specified by:
    `invalidate` in interface `javax.servlet.http.HttpSession`
  Throws:
    `java.lang.IllegalStateException` - if this method is called on an invalidated session

### isNew

    public boolean isNew()

  Return `true` if the client does not yet know about the session, or if the client chooses not to join the session. For example, if the server used only cookie-based sessions, and the client has disabled the use of cookies, then a session would be new on each request.

  Specified by:
    `isNew` in interface `javax.servlet.http.HttpSession`
  Returns:
    `true` if the server has created a session, but the client has not yet joined
  Throws:
    `java.lang.IllegalStateException` - if this method is called on an invalidated session

### putValue

    public void putValue(java.lang.String name,
                         java.lang.Object value)

  Deprecated. As of Version 2.2, this method is replaced by `setAttribute()`

  Bind an object to this session, using the specified name. If an object of the same name is already bound to this session, the object is replaced.

  After this method executes, and if the object implements `HttpSessionBindingListener`, the container calls `valueBound()` on the object.

  Specified by:
    `putValue` in interface `javax.servlet.http.HttpSession`
  Parameters:
    `name` - Name to which the object is bound, cannot be null
    `value` - Object to be bound, cannot be null
  Throws:
    `java.lang.IllegalStateException` - if this method is called on an invalidated session

### removeAttribute

    public void removeAttribute(java.lang.String name)

  Remove the object bound with the specified name from this session. If the session does not have an object bound with this name, this method does nothing.

  After this method executes, and if the object implements `HttpSessionBindingListener`, the container calls `valueUnbound()` on the object.

  Specified by:
    `removeAttribute` in interface `javax.servlet.http.HttpSession`
  Parameters:
    `name` - Name of the object to remove from this session.
  Throws:
    `java.lang.IllegalStateException` - if this method is called on an invalidated session

### removeAttribute

    public void removeAttribute(java.lang.String name,
                                boolean notify)

  Remove the object bound with the specified name from this session. If the session does not have an object bound with this name, this method does nothing.

  After this method executes, and if the object implements `HttpSessionBindingListener`, the container calls `valueUnbound()` on the object.

  Parameters:
    `name` - Name of the object to remove from this session.
    `notify` - Should we notify interested listeners that this attribute is being removed?
  Throws:
    `java.lang.IllegalStateException` - if this method is called on an invalidated session

### removeValue

    public void removeValue(java.lang.String name)

  Deprecated. As of Version 2.2, this method is replaced by `removeAttribute()`

  Remove the object bound with the specified name from this session. If the session does not have an object bound with this name, this method does nothing.

  After this method executes, and if the object implements `HttpSessionBindingListener`, the container calls `valueUnbound()` on the object.

  Specified by:
    `removeValue` in interface `javax.servlet.http.HttpSession`
  Parameters:
    `name` - Name of the object to remove from this session.
  Throws:
    `java.lang.IllegalStateException` - if this method is called on an invalidated session

### setAttribute

    public void setAttribute(java.lang.String name,
                             java.lang.Object value)

  Bind an object to this session, using the specified name. If an object of the same name is already bound to this session, the object is replaced.

  After this method executes, and if the object implements `HttpSessionBindingListener`, the container calls `valueBound()` on the object.

  Specified by:
    `setAttribute` in interface `javax.servlet.http.HttpSession`
  Parameters:
    `name` - Name to which the object is bound, cannot be null
    `value` - Object to be bound, cannot be null
  Throws:
    `java.lang.IllegalArgumentException` - if an attempt is made to add a non-serializable object in an environment marked distributable.
    `java.lang.IllegalStateException` - if this method is called on an invalidated session

### setAttribute

    public void setAttribute(java.lang.String name,
                             java.lang.Object value,
                             boolean notify)

  Bind an object to this session, using the specified name. If an object of the same name is already bound to this session, the object is replaced.

  After this method executes, and if the object implements `HttpSessionBindingListener`, the container calls `valueBound()` on the object.

  Parameters:
    `name` - Name to which the object is bound, cannot be null
    `value` - Object to be bound, cannot be null
    `notify` - whether to notify session listeners
  Throws:
    `java.lang.IllegalArgumentException` - if an attempt is made to add a non-serializable object in an environment marked distributable.
    `java.lang.IllegalStateException` - if this method is called on an invalidated session

### isValidInternal

    protected boolean isValidInternal()

  Return the `isValid` flag for this session without any expiration check.

### readObject

    protected void readObject(java.io.ObjectInputStream stream)
                       throws java.lang.ClassNotFoundException,
                              java.io.IOException

  Read a serialized version of this session object from the specified object input stream.

  IMPLEMENTATION NOTE: The reference to the owning Manager is not restored by this method, and must be set explicitly.

  Parameters:
    `stream` - The input stream to read from
  Throws:
    `java.lang.ClassNotFoundException` - if an unknown class is specified
    `java.io.IOException` - if an input/output error occurs

### writeObject

    protected void writeObject(java.io.ObjectOutputStream stream)
                        throws java.io.IOException

  Write a serialized version of this session object to the specified object output stream.

  IMPLEMENTATION NOTE: The owning Manager will not be stored in the serialized representation of this Session. After calling `readObject()`, you must set the associated Manager explicitly.

  IMPLEMENTATION NOTE: Any attribute that is not Serializable will be unbound from the session, with appropriate actions if it implements HttpSessionBindingListener. If you do not want any such attributes, be sure the `distributable` property of the associated Manager is set to `true`.

  Parameters:
    `stream` - The output stream to write to
  Throws:
    `java.io.IOException` - if an input/output error occurs

### exclude

    protected boolean exclude(java.lang.String name)

  Exclude attribute that cannot be serialized.

  Parameters:
    `name` - the attribute's name

### fireContainerEvent

    protected void fireContainerEvent(Context context,
                                      java.lang.String type,
                                      java.lang.Object data)
                               throws java.lang.Exception

  Fire container events if the Context implementation is the `org.apache.catalina.core.StandardContext`.

  Parameters:
    `context` - Context for which to fire events
    `type` - Event type
    `data` - Event data
  Throws:
    `java.lang.Exception` - occurred during event firing

### fireSessionEvent

    public void fireSessionEvent(java.lang.String type,
                                 java.lang.Object data)

  Notify all session event listeners that a particular event has occurred for this Session. The default implementation performs this notification synchronously using the calling thread.

  Parameters:
    `type` - Event type
    `data` - Event data

### keys

    protected java.lang.String[] keys()

  Return the names of all currently defined session attributes as an array of Strings. If there are no defined attributes, a zero-length array is returned.

### removeAttributeInternal

    protected void removeAttributeInternal(java.lang.String name,
                                           boolean notify)

  Remove the object bound with the specified name from this session. If the session does not have an object bound with this name, this method does nothing.

  After this method executes, and if the object implements `HttpSessionBindingListener`, the container calls `valueUnbound()` on the object.

  Parameters:
    `name` - Name of the object to remove from this session.
    `notify` - Should we notify interested listeners that this attribute is being removed?

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2008 Apache Software Foundation. All Rights Reserved.